% filter_exa_solution.m, 30-4-2008, version 1.3

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp(' exercise 4: use the last 80 data points only in the exercise')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

data = xlsread('BCEP_us.xls');
sample=[71:151];
dates=data(71:150,1);

% extract series of interest from the data file
deficit=data(sample,16);
gap=data(sample,17);
cpi=data(sample,21);
r=data(sample,22);

ddd =[deficit gap cpi r];
endd=length(ddd);

% demean nominal variables (cpi and r)
%dynm = mean(ddd(:,3:4)); 
%dyn  = ddd(:,3:4)-kron(dynm,ones(length(data),1));

% set up constant and linear trend
T = 1:1:length(ddd);
X = [ones(length(ddd),1), T'];

% detrend real variables (gap and deficit):
%for i=1:size(ddd,2)-2
%     dyo(:,i) = ddd(:,i) - X*(X'*X)^-1*X'*ddd(:,i);
%end
%clear i T X
%dy1=[dyo, dyn];

% if you want to linearly detrend all the variables use
for i=1:size(ddd,2)
     dyo(:,i) = ddd(:,i) - X*(X'*X)^-1*X'*ddd(:,i);
end
clear i T X
dy1=dyo;

% if you all variables linearly detrended with multivariate trend use
% dyo = ddd -X*(X'*X)^-1*X'*ddd;
% dy1=dyo;

% HP filtered data only real variables
%dy2=[ddd(:,1:2)-Hpfilter(ddd(:,1:2),1600), dyn];

% HP filtering all the series
dy2=[ddd(:,1:4)-Hpfilter(ddd(:,1:4),1600)];

%first difference only real variables
%ddy3=[ddd(2:end,1:2)-ddd(1:end-1,1:2), dyn(2:end,:)];
% eliminating the mean from real variables
%dy3(:,:)=ddy3(:,:)-mean(ddy3(1,:));

% FOD all variables 
ddy3=[ddd(2:endd,1:4)-ddd(1:endd-1,1:4)];
% eliminate the mean from real variables
dy3(:,:)=ddy3(:,:)-mean(ddy3(1,:));


%dy4= [ ];
% baxter and king filter real variables use
%for i=1:size(ddd,2)-2
%    dycc = bkfilter(ddd(:,i),6,32);
%dy4 = [dy4 dycc];
%end
%dy4 = [dy4 dyn];

dy4= [ ];
  % baxter and king filter all variables
for i=1:size(ddd,2)
    dycc = bkfilter(ddd(:,i),6,32);
dy4 = [dy4 dycc];
end

% Christiano-fitzgerald filter 
% for a symmetric filter (the same as bk)
% cfcpi = cffilter(x,6,32);
% asymmteric filter
% for details see the file cffilter.m

% CF filter only real data
%dy5 = cffilter(ddd(:,1:2),6,32,0,1,0);
% CF filter all the data
dy5 = cffilter(ddd(:,1:4),6,32,0,1,0);

% collect cyclical components of cpi and plot them
xxc=[dy1(2:endd,3:3) dy2(2:endd,3:3) dy3(1:endd-1,3:3) dy4(2:endd,3:3) dy5(2:endd,3:3)];
figure(1)
plot(dates,dy1(2:endd,3:3),'r', dates,dy2(2:endd,3:3),'b',dates, dy3(1:endd-1,3:3),'g', dates, dy4(2:endd,3:3),'k',dates, dy5(2:endd,3:3),'m') % 
legend('LT', 'HP', 'FOD', 'BK', 'CF')

% calculation of autocorrelations and cross correlations 
% (the dimension of auto1 is 3*(4+1) times 3) with blocks of
% cross correlations at 0,1,2,3,4.
auto1=autocor(xxc,4)

%%%%%%%%%%%%%%%%%%%%%%%% exercises  %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
disp(' exercise 5: use the data ylph.txt (output, labor productivity and hours) to compute cyclical components of the three variables')
%              compare them to those obtaiend with a BQ and BN
%              decompositions (see program BQBN_decomp.m)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


load ylph.txt;              %
[nobs,nvar] = size(ylph);   % # Observations in time series
y = ylph(:,1); % log y
lp = ylph(:,2); % log lp
nb = ylph(:,3);  % log hours 

time    = 1955:0.25:2000.50;
deb     = find(time==1955.25);
fin     = find(time==2000.50);
smpl    = deb:fin;

% set up constant and linear trend
T = 1:1:length(lp);
X = [ones(length(lp),1), T'];

dy1 = lp - X*(X'*X)^-1*X'*lp;
dy2=[lp-Hpfilter(lp,1600)];

ddy3=[lp(2:fin)-lp(1:fin-1)];
dy3=ddy3-mean(ddy3);

dy4 = bkfilter(lp,6,32);
dy5 = cffilter(lp,6,32,0,1,0);

% collect cyclical components of lp and plot them

time1    = 1955.25:0.25:2000.50;

figure(2)
plot(time1',dy1(2:fin),'r', time1',dy2(2:fin),'b',time1',dy3(1:fin-1),'g', time1',dy4(2:fin),'k',time1',dy5(2:fin),'m') % 
legend('LT', 'HP', 'FOD', 'BK', 'CF')

 